#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.8.14.1 $
#
#   last change: $Author: armin $ $Date: 2001/08/16 14:02:14 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc..
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..

PRJNAME=	i18n
TARGET=		unotypes

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

# ------------------------------------------------------------------

UNOUCRDEP=$(SOLARBINDIR)$/applicat.rdb
UNOUCRRDB=$(SOLARBINDIR)$/applicat.rdb
UNOUCROUT=$(OUT)$/inc

CPPUMAKERFLAGS=

UNOTYPES= \
	com.sun.star.i18n.AmPmValue \
	com.sun.star.i18n.Calendar \
	com.sun.star.i18n.CalendarDisplayIndex \
	com.sun.star.i18n.CalendarFieldIndex \
	com.sun.star.i18n.CalendarItem \
	com.sun.star.i18n.DirectionProperty \
	com.sun.star.i18n.KCharacterType \
	com.sun.star.i18n.KNumberFormatType \
	com.sun.star.i18n.KNumberFormatUsage \
	com.sun.star.i18n.KParseTokens \
	com.sun.star.i18n.KParseType \
	com.sun.star.i18n.Months \
	com.sun.star.i18n.ParseResult \
	com.sun.star.i18n.UnicodeScript \
	com.sun.star.i18n.UnicodeType \
	com.sun.star.i18n.Weekdays \
	com.sun.star.i18n.XCalendar \
	com.sun.star.i18n.XCharacterClassification \
	com.sun.star.i18n.XLocaleData \
	com.sun.star.i18n.XNumberFormatCode \
	com.sun.star.lang.XMultiServiceFactory \
	com.sun.star.lang.XServiceInfo \
	com.sun.star.lang.XServiceName \
	com.sun.star.lang.XSingleServiceFactory \
	com.sun.star.lang.XTypeProvider \
	com.sun.star.lang.XUnoTunnel \
	com.sun.star.registry.XRegistryKey \
	com.sun.star.style.BreakType \
	com.sun.star.i18n.CharType \
	com.sun.star.i18n.CharacterIteratorMode \
	com.sun.star.i18n.ScriptType \
	com.sun.star.i18n.WordType \
	com.sun.star.i18n.XBreakIterator \
	com.sun.star.uno.TypeClass \
	com.sun.star.uno.XAggregation \
	com.sun.star.uno.XWeak \
	com.sun.star.i18n.XCollator \
    com.sun.star.i18n.XTransliteration \
    com.sun.star.i18n.TransliterationType \
    com.sun.star.i18n.TransliterationModules \
    com.sun.star.i18n.TransliterationModulesNew

# --- Targets ------------------------------------------------------

.INCLUDE :	target.mk
