/*************************************************************************
 *
 *  $RCSfile: app.cxx,v $
 *
 *  $Revision: 1.21 $
 *
 *  last change: $Author: thb $ $Date: 2001/07/31 12:19:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <stdio.h>

#ifndef _COM_SUN_STAR_CONTAINER_XSET_HPP_
#include <com/sun/star/container/XSet.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSINGLESERVICEFACTORY_HPP_
#include <com/sun/star/lang/XSingleServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XCOMMANDENVIRONMENT_HDL_
#include <com/sun/star/ucb/XCommandEnvironment.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_COMMANDABORTEDEXCEPTION_HDL_
#include <com/sun/star/ucb/CommandAbortedException.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_ANY_H_
#include <com/sun/star/uno/Any.h>
#endif
#ifndef _UCBHELPER_CONTENTBROKER_HXX 
#include <ucbhelper/contentbroker.hxx>
#endif
#ifndef _UCBHELPER_CONTENT_HXX
#include <ucbhelper/content.hxx>
#endif
#ifndef _UCBHELPER_CONFIGURATIONKEYS_HXX_
#include <ucbhelper/configurationkeys.hxx>
#endif

#ifndef _OSL_PROCESS_H_
#include <osl/process.h>
#endif
#ifndef _OSL_SECURITY_H_
#include <osl/security.h>
#endif
#ifndef _OSL_FILE_HXX_
#include <osl/file.hxx>
#endif
#ifndef _RTL_LOGFILE_HXX_
#include <rtl/logfile.hxx>
#endif
#ifndef _VOS_PROCESS_HXX_
#include <vos/process.hxx>
#endif
#ifndef _VOS_PROFILE_HXX_
#include <vos/profile.hxx>
#endif
#ifndef AUTOMATION_HXX
#include <automation/automation.hxx>
#endif

#ifndef _XMLOFF_XMLREG_HXX
#include <xmloff/xmlreg.hxx>
#endif

#include <unotools/processfactory.hxx>
#include <unotools/localfilehelper.hxx>
#include <unotools/configmgr.hxx>
#include <unotools/tempfile.hxx>
#ifndef _CPPUHELPER_SERVICEFACTORY_HXX_
#include "cppuhelper/servicefactory.hxx"
#endif

#ifndef _CPPUHELPER_FACTORY_HXX_
#include <cppuhelper/factory.hxx>
#endif
#ifndef _TOOLS_RESMGR_HXX //autogen
#include <tools/resmgr.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen wg. ErrorBox
#include <vcl/msgbox.hxx>
#endif
#ifndef INCLUDED_SVTOOLS_LOCALISATIONOPTIONS_HXX
#include <svtools/localisationoptions.hxx>
#endif
#if SUPD < 600
#ifndef SVTOOLS_TESTTOOL_HXX //autogen
#include <svtools/testtool.hxx>
#endif
#else
#ifndef AUTOMATION_HXX //autogen
#include <automation/automation.hxx>
#endif
#endif
#ifndef _EHDL_HXX //autogen
#include <svtools/ehdl.hxx>
#endif
#ifndef _SVTOOLS_HRC
#include <svtools/svtools.hrc>
#endif
#ifndef _INETHIST_HXX
#include <svtools/inethist.hxx>
#endif

#ifndef _SVDOUTL_HXX
#include <svx/svdoutl.hxx>
#endif
#ifndef _SVX_ITEMDATA_HXX //autogen
#include <svx/itemdata.hxx>
#endif
#ifndef _EERDLL_HXX //autogen
#include <svx/editdll.hxx>
#endif
#ifndef _EEITEM_HXX //autogen
#include <svx/eeitem.hxx>
#endif
#define ITEMID_FIELD    EE_FEATURE_FIELD
#ifndef _SVX_FLDITEM_HXX //autogen
#include <svx/flditem.hxx>
#endif
#ifndef _SVDFIELD_HXX //autogen
#include <svx/svdfield.hxx>
#endif
#ifndef _OBJFAC3D_HXX //autogen
#include <svx/objfac3d.hxx>
#endif
#ifndef _SVDOBJ_HXX //autogen
#include <svx/svdobj.hxx>
#endif
#ifndef _SVDPAGV_HXX
#include <svx/svdpagv.hxx>
#endif
#ifndef _SVDETC_HXX
#include <svx/svdetc.hxx>
#endif
#ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX
#include <svtools/pathoptions.hxx>
#endif
#include <svtools/syslocaleoptions.hxx>

#ifndef _SDOBJFAC_HXX
#include <sd/sdobjfac.hxx>
#endif
#ifndef _DRAWDOC_HXX
#include <sd/drawdoc.hxx>
#endif
#ifndef _SDPAGE_HXX
#include <sd/sdpage.hxx>
#endif

#include "appwin.hxx"
#include "viewshel.hxx"
#include "centraldlg.hxx"
#include "datasrc.hxx"
#include "app.hxx"
#include "sdresid.hxx"
#include "strings.hrc"
#include "sip.hrc"
#include "rscrev.hxx"
#include <comphelper/regpathhelper.hxx>




// declarations
// ----------------------------------------------------------------------------

// convenience alias 
namespace css = ::com::sun::star;

class GraphicFilter;
extern GraphicFilter* GetGrfFilter();

class SIPApp_Impl
{
public:
	EditDLL*			m_pEditDLL;
	SipViewShell*		m_pViewShell;
};

// this avoids trouble with office tmp dir (temp/soffice.tmp)
#define PLAYER_TEMPNAMEBASE_DIR     "$(userpath)/temp/player.tmp"


// statics
// ----------------------------------------------------------------------------
ResMgr*				pDeskResMgr = 0;

SIPApp 				aDesktop;

const char 			pPathKey[] = "Path";

static String 		aTempNameBaseDir;
static String 		aTempBase;

static oslModule	aTestToolModule		= 0;


// various initialisation funcs
// ----------------------------------------------------------------------------

BOOL createServiceAndUcb()
{
    /////////////////////////////////////////////////////////////////////
    // Create Process Service Manager. This needs to be done only once
    // per process! Afterwards it is accessable via
    // comphelper::getProcessServiceFactory().
    /////////////////////////////////////////////////////////////////////

    css::uno::Reference< css::lang::XMultiServiceFactory > xServiceFactory;
    try
    {
        xServiceFactory = cppu::createRegistryServiceFactory(
                                  comphelper::getPathToSystemRegistry(),
                                  rtl::OUString(),
                                  true );
		if ( !xServiceFactory.is() )
			return sal_False;

		comphelper::setProcessServiceFactory( xServiceFactory );

		/////////////////////////////////////////////////////////////////////
		// Create UCB. This needs to be done only once per process!
		/////////////////////////////////////////////////////////////////////

		// Supply normal configuration to use for this UCB instance...
		css::uno::Sequence< css::uno::Any > aArgs( 2 );
		aArgs[ 0 ] <<= OUString::createFromAscii( UCB_CONFIGURATION_KEY1_LOCAL );
		aArgs[ 1 ] <<= OUString::createFromAscii( UCB_CONFIGURATION_KEY2_OFFICE );
		sal_Bool bSuccess = ::ucb::ContentBroker::initialize( xServiceFactory, aArgs );
		
		if ( !bSuccess )
		{
			DBG_ERROR( "Error creating UCB!" );
			return sal_False;
		}

		/////////////////////////////////////////////////////////////////////
		// manually register XML Office components
		/////////////////////////////////////////////////////////////////////

		return XMLRegisterServices( xServiceFactory );
    }
    catch( css::uno::Exception& ) { return sal_False; }

    return sal_True;
}


// ----------------------------------------------------------------------------

void ReplaceStringHookProc( UniString& rStr )
{
    static String aBrandName;
    static String aVersion;
	static String aExtension;

    if ( !aBrandName.Len() )
    {
        css::uno::Any aRet = ::utl::ConfigManager::GetDirectConfigProperty( ::utl::ConfigManager::PRODUCTNAME );
        rtl::OUString aTmp;
        aRet >>= aTmp;
        aBrandName = aTmp;

        aRet = ::utl::ConfigManager::GetDirectConfigProperty( ::utl::ConfigManager::PRODUCTVERSION );
        aRet >>= aTmp;
#ifdef DEBUG
		aTmp += String::CreateFromAscii(" [" RSCUPDVER "]");
#endif
        aVersion = aTmp;

		aRet = ::utl::ConfigManager::GetDirectConfigProperty( ::utl::ConfigManager::PRODUCTEXTENSION );
        aRet >>= aTmp;
        aExtension = aTmp;
    }

	if ( rStr.SearchAscii( "%PRODUCT" ) != STRING_NOTFOUND )
	{
     	rStr.SearchAndReplaceAllAscii( "%PRODUCTNAME", aBrandName );
 		rStr.SearchAndReplaceAllAscii( "%PRODUCTVERSION", aVersion );
 		rStr.SearchAndReplaceAllAscii( "%PRODUCTEXTENSION", aExtension );
	}
}


// ----------------------------------------------------------------------------

sal_Bool KillFiles( const String& rContent )
{
	sal_Bool bRet = sal_True;
    INetURLObject aDeleteObj( rContent );
    DBG_ASSERT( aDeleteObj.GetProtocol() != INET_PROT_NOT_VALID, "Invalid URL!" );

	try
	{
		::ucb::Content aCnt( aDeleteObj.GetMainURL( INetURLObject::NO_DECODE ), css::uno::Reference< css::ucb::XCommandEnvironment > () );
		aCnt.executeCommand( OUString::createFromAscii( "delete" ), makeAny( sal_Bool( sal_True ) ) );
	}
	catch( css::uno::Exception& )
	{
		// something went wrong
		bRet = sal_False;
	}

	return bRet;
}


// ----------------------------------------------------------------------------

void InitTestToolLib()
{
	RTL_LOGFILE_CONTEXT( aLog, "desktop (cd) ::InitTestToolLib" );

	OUString	aFuncName( RTL_CONSTASCII_USTRINGPARAM( "CreateRemoteControl" ));
	OUString	aModulePath;

	::vos::OStartupInfo().getExecutableFile( aModulePath );
	sal_uInt32 	lastIndex = aModulePath.lastIndexOf('/');
	if ( lastIndex > 0 )
		aModulePath = aModulePath.copy( 0, lastIndex+1 );
	
	aModulePath += OUString::createFromAscii( SVLIBRARY( "sts" ) );

	// Shortcut for Performance: We expect that the test tool library is not installed
	// (only for testing purpose). It should be located beside our executable.
	// We don't want to pay for searching through LD_LIBRARY_PATH so we check for
	// existence only in our executable path!!
	osl::DirectoryItem	aItem;
	osl::FileBase::RC	nResult = osl::DirectoryItem::get( aModulePath, aItem );
	
	if ( nResult == osl::FileBase::E_None )
	{
		aTestToolModule = osl_loadModule( aModulePath.pData, SAL_LOADMODULE_DEFAULT );
		if ( aTestToolModule )
		{
			void* pInitFunc = osl_getSymbol( aTestToolModule, aFuncName.pData );
			if ( pInitFunc )
				(*(pfunc_CreateRemoteControl)pInitFunc)();
		}
	}
}

void DeInitTestToolLib()
{
	if ( aTestToolModule )
	{
		OUString	aFuncName( RTL_CONSTASCII_USTRINGPARAM( "DestroyRemoteControl" ));
		
		void* pDeInitFunc = osl_getSymbol( aTestToolModule, aFuncName.pData );
		if ( pDeInitFunc )
			(*(pfunc_DestroyRemoteControl)pDeInitFunc)();
			
		osl_unloadModule( aTestToolModule );
	}
}


// ----------------------------------------------------------------------------
// application
// ----------------------------------------------------------------------------

SIPApp::SIPApp():
	Application()
{
	m_pImpl = new SIPApp_Impl();

	m_pImpl->m_pEditDLL = NULL;
	m_pImpl->m_pViewShell = NULL;

//	SvFactory::Init();
//	SvFactory::ClearDemandObjects();;
}

SIPApp::~SIPApp()
{
//	SvFactory::DeInit();

	delete m_pImpl;
}

void SIPApp::Main( ) //__EXPORT
{
	const String aAppName( String::CreateFromAscii("sop") );

 	SetAppName( aAppName );
    ResMgr::SetReadStringHook( ReplaceStringHookProc );

	SvxGlobalItemData aItemData;

	if(!createServiceAndUcb())
	{
		ErrorBox aErrorBox(NULL, WB_OK, String::CreateFromAscii("Configuration files incomplete") );
		aErrorBox.Execute();
		return;
	}

/* !!! IniManager
    SfxIniManager* pIniMgr = SfxIniManager::Create( &aAppName );
	if( pIniMgr == NULL )
	{
#ifdef UNX
		ErrorBox aErrorBox(NULL, WB_OK, String::CreateFromAscii("File 'soprc' not found"));
#else
		ErrorBox aErrorBox(NULL, WB_OK, String::CreateFromAscii("File 'sop.ini' not found"));
#endif
		aErrorBox.Execute();
		return;
	}
	else
	{
		pIniMgr->LeaveLock();
	}
*/

	// from sfx2/source/appl/app.cxx
	String sLanguage = SvtPathOptions().SubstituteVariable(String::CreateFromAscii("$(langid)"));
    LanguageType eUILanguage = (LanguageType) sLanguage.ToInt32();
    LanguageType eLanguage = SvtSysLocaleOptions().GetLocaleLanguageType();
    AllSettings aSettings( Application::GetSettings() );
    aSettings.SetUILanguage( eUILanguage );
    aSettings.SetLanguage( eLanguage );
    Application::SetSettings( aSettings );

	pDeskResMgr = CREATERESMGR( sop );
	Resource::SetResManager( pDeskResMgr );
	
	EnableAutoHelpId();
	// disabled, now loading automation lib on demand
	// RemoteControl aRemote;

	InitMain();
	
	::utl::ConfigManager* pCfgMgr = new ::utl::ConfigManager;

    // Dialog-Mnemonics/Scaling
	SvtLocalisationOptions	aLocalOpt;

	sal_Bool bAutoMnemonic = aLocalOpt.IsAutoMnemonic();
    Application::EnableAutoMnemonic( bAutoMnemonic );
	sal_uInt16 nScale = (short) aLocalOpt.GetDialogScale();
    Application::SetDialogScaleX( nScale );

	mpAppWindow = new WorkWindow( NULL, WB_APP );
	if( mpAppWindow )
	{
		String aTitle(SdResId(STR_PLAYER_TITLE));

		mpAppWindow->SetText(aTitle);
	}

	if( Application::GetCommandLineParamCount() != 0 )
	{
		OpenCommandLineFile();
	}
	else
	{
		OpenFileDialog();
	}

	delete mpAppWindow;
	delete pCfgMgr;
	mpAppWindow = NULL;
	ExitMain();
}

void SIPApp::OpenFileDialog()
{
	INetURLObject	aURL;
	String			aURLStr;

	::utl::LocalFileHelper::ConvertPhysicalNameToURL( GetAppFileName(), aURLStr );

	aURL.SetURL( aURLStr );
	aURL.removeSegment();
	aURL.removeFinalSlash();

	do
	{
		{
			SipCentralDlg	aDlg(NULL, aURL.GetMainURL( INetURLObject::NO_DECODE ));

			if( aDlg.Execute() == 0 )
				break;
			
			aURL.SetURL(aDlg.GetPathURL());
		}

		if( aURL.GetProtocol() != INET_PROT_NOT_VALID )
		{
			Options		aOptions;	

			m_pImpl->m_pViewShell = new SipViewShell(NULL, aOptions);
			if( m_pImpl->m_pViewShell->Load( aURL.GetMainURL( INetURLObject::NO_DECODE ) ) )
			{
				m_pImpl->m_pViewShell->StartSlideShow();
				do
				{
					Application::Yield();
				}
				while( !IsShutDown() && m_pImpl->m_pViewShell->IsSlideShowRunning() );
			}
			DELETEZ( m_pImpl->m_pViewShell );

			Application::Reschedule();
		}
	}
	while( !IsShutDown() );
}

void SIPApp::OpenCommandLineFile()
{
	String		aFile;
	Options		aOptions(FALSE);	// non-persistent options	

	const USHORT nParamCount = Application::GetCommandLineParamCount();
	for( USHORT nParam = 0; nParam < nParamCount; nParam++ )
	{
		String aParam( Application::GetCommandLineParam( nParam ) );
		if( aParam.Len() >= 2 )
		{
			if( aParam.GetChar(0) == '-' )
			{
				switch( aParam.GetChar(1) )
				{ 
					// auto slide-switching
					case 'a':
						aOptions.SetPresChange(1);	// manual	
						break;
					case 'A':
						aOptions.SetPresChange(3);	// automatic	
						break;

					// loop presentation
					case 'l':
						aOptions.SetEndless(STATE_NOCHECK);	// disabled	
						break;
					case 'L':
						aOptions.SetEndless(STATE_CHECK);	// enabled	
						break;
										
					// fullscreen presentation window
					case 'f':
						aOptions.SetFullScreen(STATE_NOCHECK);	// disabled	
						break;
					case 'F':
						aOptions.SetFullScreen(STATE_CHECK);	// enabled	
						break;
										
					// kiosk mode: includes options A, L, F and forcing the 
					// presentation window into foreground		
					case 'K':
						aOptions.SetPresChange(3);				// automatic	
						aOptions.SetEndless(STATE_CHECK);		// enabled	
						aOptions.SetFullScreen(STATE_CHECK);	// enabled	
						aOptions.SetAlwaysOnTop(STATE_CHECK);	// enabled	
						break;

					default:
						aParam += String::CreateFromAscii(": ");
						aParam += String(SdResId(STR_COMMANDLINE_HELP));
						ErrorBox aErrorBox(NULL, WB_OK, aParam );
						aErrorBox.Execute();
						return;
				} 
			}
			else
			{
				aFile = aParam;
			}
		}
	}

	m_pImpl->m_pViewShell = new SipViewShell(NULL, aOptions);

	if( aFile.Len() )
	{
		::rtl::OUString aRet;

		// convert filename to URL
		if( ::osl::FileBase::getFileURLFromSystemPath( aFile, aRet ) == ::osl::FileBase::E_None )
		{
			aFile = aRet;
		}
		// else: maybe it *is* already a file URL!

		// do we now have a valid URL name?
		INetURLObject aURL( aFile );		
		if( aURL.GetProtocol() == INET_PROT_NOT_VALID )
		{
			::rtl::OUString aCurrDir;

			// no, try to prepend current working dir	
			osl_getProcessWorkingDir(&aCurrDir.pData);
				
			::osl::FileBase::getAbsoluteFileURL( aCurrDir, aFile, aRet );
		}

		if( m_pImpl->m_pViewShell->Load( aRet ) )
		{
			m_pImpl->m_pViewShell->StartSlideShow();
			do
			{
				Application::Reschedule();
			}
			while( !IsShutDown() && m_pImpl->m_pViewShell->IsSlideShowRunning() );
		}
	}

	DELETEZ( m_pImpl->m_pViewShell );
}

void SIPApp::InitMain()
{
#ifdef DBG_UTIL
	// Der SimplerErrorHandler dient Debugzwecken. In der Product werden
	// nichtgehandelte Fehler durch Errorcode 1 an SFX gegeben.
	new SimpleErrorHandler;
#endif
	new SfxErrorHandler(RID_ERRHDL, ERRCODE_AREA_TOOLS, ERRCODE_AREA_LIB1);

	// Application::RegisterUnoServices();

	//////////////////////////////////////////////////////////////////////
	// set temp base directory
	//////////////////////////////////////////////////////////////////////

    // remove old temp dir
    SvtPathOptions aOpt;
    String aTemp( RTL_CONSTASCII_USTRINGPARAM( PLAYER_TEMPNAMEBASE_DIR ) );
    aTempNameBaseDir = aOpt.SubstituteVariable( aTemp );
    String aOldTempBase( aOpt.GetTempPath() );
    if ( STRING_NOTFOUND != aOldTempBase.Search( aTempNameBaseDir ) )
    {
        String aRet;
        ::utl::LocalFileHelper::ConvertPhysicalNameToURL( aOldTempBase, aRet );
        KillFiles( aRet );
    }

	// set temp base directory
    ::rtl::OUString aRet;
    ::osl::FileBase::getFileURLFromSystemPath( aTempNameBaseDir, aRet );
    ::utl::TempFile::SetTempNameBaseDirectory( aRet );
    aTempBase = ::utl::TempFile::SetTempNameBaseDirectory( aRet );
    aOpt.SetTempPath( aTempBase );

	// perform dynamic load of testtool lib (if available)
	InitTestToolLib();

	// set filter path manually
	//GetGrfFilter().SetFilterPath(<path>);
	GetGrfFilter();

	m_pImpl->m_pEditDLL = new EditDLL;

	// SvxURLField registrieren
	SvClassManager& rClassManager = SvxFieldItem::GetClassManager();
	rClassManager.SV_CLASS_REGISTER( SvxURLField );
	rClassManager.SV_CLASS_REGISTER( SvxDateField );
	rClassManager.SV_CLASS_REGISTER( SvxPageField );
	rClassManager.SV_CLASS_REGISTER( SvxTimeField );
	rClassManager.SV_CLASS_REGISTER( SvxExtTimeField );
	rClassManager.SV_CLASS_REGISTER( SvxExtFileField );
	rClassManager.SV_CLASS_REGISTER( SvxAuthorField );

	// SvDraw-Felder registrieren
	SdrRegisterFieldClasses();

	// 3D-Objekt-Factory eintragen
	E3dObjFactory();

	// Form-Objekt-Factory eintragen
	//FmFormObjFactory();

	// Impress Objekt-Factory eintragen
	SdrObjFactory::InsertMakeUserDataHdl(LINK(&aSdObjectFactory, SdObjectFactory, MakeUserData));
}

void SIPApp::ExitMain()
{
	// Impress Objekt-Factory austragen
	SdrObjFactory::RemoveMakeUserDataHdl(LINK(&aSdObjectFactory, SdObjectFactory, MakeUserData));

	Resource::SetResManager( NULL );

	// release testtool lib (if loaded, that is)
	DeInitTestToolLib();

	// remove temp directory
    if ( STRING_NOTFOUND != aTempBase.Search( aTempNameBaseDir ) )
	{
        String aRet;
        ::utl::LocalFileHelper::ConvertPhysicalNameToURL( aTempBase, aRet );
        if ( KillFiles( aRet ) )
		{
            SvtPathOptions().SetTempPath( String() );
            ::utl::LocalFileHelper::ConvertPhysicalNameToURL( aTempNameBaseDir, aRet );
            KillFiles( aRet );
		}
	}

	delete ( &GetSdrGlobalData() )->pOutliner;  // vor EditDLL, wegen Static-Defaults
	( &GetSdrGlobalData() )->pOutliner = NULL;

	delete m_pImpl->m_pEditDLL;

	delete &GetSdrGlobalData();
}


/*************************************************************************
|*
|* Link fuer CalcFieldValue des Outliners
|*
\************************************************************************/

IMPL_LINK(SIPApp, CalcFieldValueHdl, EditFieldInfo*, pInfo)
{
	if (pInfo)
	{
		const SvxFieldItem& rField = pInfo->GetField();
		const SvxFieldData* pField = rField.GetField();

		if (pField && pField->ISA(SvxDateField))
		{
			/******************************************************************
			* Date-Field
			******************************************************************/
			pInfo->SetRepresentation(
				((const SvxDateField*) pField)->GetFormatted(LANGUAGE_SYSTEM,
															 LANGUAGE_SYSTEM) );
		}
		else if( pField && pField->ISA( SvxExtTimeField ) )
		{
			/******************************************************************
			* Time-Field
			******************************************************************/
			pInfo->SetRepresentation( ( (const SvxExtTimeField*) pField)->
							GetFormatted( LANGUAGE_SYSTEM, LANGUAGE_SYSTEM ) );
		}
		else if( pField && pField->ISA( SvxExtFileField ) )
		{
			/******************************************************************
			* File-Field
			******************************************************************/
			const SvxExtFileField* pFileField = (const SvxExtFileField*) pField;
			String aFile;
			if( pFileField->GetType() == SVXFILETYPE_FIX )
				aFile =  pFileField->GetFormatted();
			else
			{
				if(m_pImpl->m_pViewShell )
				{
					SvxExtFileField aFileField( *pFileField );
					aFileField.SetFile( m_pImpl->m_pViewShell->GetPath() );
					aFile = aFileField.GetFormatted();
				}
			}

			pInfo->SetRepresentation( aFile );

		}
		else if( pField && pField->ISA( SvxAuthorField ) )
		{
			/******************************************************************
			* Author-Field
			******************************************************************/
			const SvxAuthorField* pAuthorField = (const SvxAuthorField*) pField;
			String aAuthor;

			aAuthor = pAuthorField->GetFormatted();
			pInfo->SetRepresentation( aAuthor );

		}
		else if( pField && pField->ISA( SvxPageField ) )
        {
			/******************************************************************
			* Page-Field

			******************************************************************/
			String aRepresentation( sal_Unicode(' ') );
			SdDrawDocument* pDoc = m_pImpl->m_pViewShell ? m_pImpl->m_pViewShell->GetDoc() : NULL;

			if( pDoc )
			{
				USHORT nPgNum = 1;

				const SdrPageView* pPV = pDoc->GetPaintingPageView();

				if (pPV)
				{
					SdPage* pPage = (SdPage*) pPV->GetPage();

					if(pPage )
						nPgNum = (pPage->GetPageNum() + 1) / 2;
				}

				aRepresentation = pDoc->CreatePageNumValue(nPgNum);
			}

			pInfo->SetRepresentation( aRepresentation );

        }
        else if (pField && pField->ISA(SvxURLField))
		{
			/******************************************************************
			* URL-Field
			******************************************************************/

			switch ( ((const SvxURLField*) pField)->GetFormat() )
			{
				case SVXURLFORMAT_APPDEFAULT: //!!! einstellbar an App???
				case SVXURLFORMAT_REPR:
				{
					pInfo->SetRepresentation(
						   ((const SvxURLField*)pField)->GetRepresentation() );
				}
				break;

				case SVXURLFORMAT_URL:
				{
					pInfo->SetRepresentation(
						   ((const SvxURLField*)pField)->GetURL() );
				}
				break;
			}

			String aURL = ((const SvxURLField*)pField)->GetURL();
			Color aColor(INetURLHistory::GetOrCreate()->QueryUrl(aURL)?COL_LIGHTRED:COL_LIGHTBLUE);
			pInfo->SetTxtColor(aColor);
		}
        else if (pField && pField->ISA(SdrMeasureField))
		{
			/******************************************************************
            * Measure-Field
			******************************************************************/
            pInfo->ClearFldColor();
        }
        else
		{
			DBG_ERROR("Unknown form command");
			pInfo->SetRepresentation(String(sal_Unicode('?')));
		}
	}

	return(0);
}


SdPage* SIPApp::GetActualPage() const
{
	if(m_pImpl->m_pViewShell )
		return m_pImpl->m_pViewShell->GetActualPage();
	else
		return NULL;
}
