
ASM=/usr/ccs/bin/as
AFLAGS=-P -q


CDEFS+=-D_PTHREADS -DSYSV -DSUN -DSUN4 -D_REENTRANT -D_POSIX_PTHREAD_SEMANTICS -DSTLPORT_VERSION=400

.IF "$(SOLAR_JAVA)"!=""
JAVADEF=-DSOLAR_JAVA
JAVAFLAGSDEBUG=-g
.IF "$(debug)"==""
JAVA_RUNTIME=-ljava
.ELSE
JAVA_RUNTIME=-ljava_g
.ENDIF
.ENDIF

CC=CC
cc=cc

.IF "$(WARN)"!=""
WARNINGS =
.ELSE
WARNINGS = -w
.ENDIF

CFLAGS=$(PREENVCFLAGS) $(WARNINGS) -c -temp=/tmp $(INCLUDE)
CFLAGSCC=-xCC
CFLAGSCXX=-features=no%altspell,no%localfor

CFLAGSEXCEPTIONS=
CFLAGS_NO_EXCEPTIONS=-noex

CFLAGSOBJGUIST=-KPIC
CFLAGSOBJCUIST=-KPIC
CFLAGSOBJGUIMT=-KPIC
CFLAGSOBJCUIMT=-KPIC
CFLAGSSLOGUIMT=-KPIC
CFLAGSSLOCUIMT=-KPIC
CFLAGSPROF=-xpg
CFLAGSDEBUG=-g
CFLAGSDBGUTIL=
CFLAGSOPT=-O
CFLAGSNOOPT=
CFLAGSOUTOBJ=-o

STDOBJVCL=$(L)$/salmain.o

THREADLIB=-lposix4
.IF "$(PURIFY)"!=""
LINK=/usr/local/purify-4.2-solaris2/purify CC
.ELSE
LINK=CC
.ENDIF

#set RPATH to prevent the compiler from setting this to his own libs
LINKFLAGS=-w -PIC -temp=/tmp -R /usr/lib

.IF "$(TARGETTHREAD)"=="MT"
#hack to get libthread.so linked first
LINKFLAGSAPPGUI=-lthread
LINKFLAGSAPPCUI=-lthread
LINKFLAGSSHLGUI=-G -lthread
LINKFLAGSSHLCUI=-G -lthread
.ELSE			# "$(TARGETTHREAD)"=="MT"
LINKFLAGSSHLGUI=-G
LINKFLAGSSHLCUI=-G
.ENDIF			# "$(TARGETTHREAD)"=="MT"

.IF "$(NO_BSYMBOLIC)"==""
.IF "$(PRJNAME)"!="schedule"
#.IF "$(PRJNAME)"!="envtest"
LINKFLAGSSHLGUI+=-Bsymbolic
LINKFLAGSSHLCUI+=-Bsymbolic
#.ENDIF
.ENDIF
.ENDIF				# "$(NO_BSYMBOLIC)"==""

# switches for dynamic and static linking
STATIC		= -Bstatic
DYNAMIC		= -Bdynamic

LINKFLAGSTACK=
LINKFLAGSPROF=-L$(COMPATH)/WS6U1/lib/libp -xpg -z allextract
LINKFLAGSDEBUG=
LINKFLAGSOPT=
LINKVERSIONMAPFLAG=-M
APPLINKSTATIC=-Bstatic
APPLINKSHARED=-Bdynamic
APP_LINKTYPE=

# reihenfolge der libs NICHT egal!
STDOBJGUI=
.IF "DBG_UTIL" != ""
STDSLOGUI=#-lpthread
.ELSE
STDSLOGUI=
.ENDIF
STDOBJCUI=
STDSLOCUI=
STDLIBGUIST=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun
STDLIBCUIST=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun
STDLIBGUIMT=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun
STDLIBCUIMT=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun
STDSHLGUIMT=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun
STDSHLCUIMT=-Bdynamic -lnsl -lsocket -ldl -lm -lCrun

STDLIBGUIST+=-lXm -lXt -lX11
STDLIBGUIMT+=-lXm -lXt -lX11

LIBSTLPORT=$(DYNAMIC) -lstlport_sunpro
LIBSTLPORTST=$(STATIC) -lstlport_sunpro $(DYNAMIC)


LIBMGR=CC
LIBFLAGS=-xar -o 

IMPLIB=
IMPLIBFLAGS=

MAPSYM=
MAPSYMFLAGS=

RC=irc
RCFLAGS=-fo$@ $(RCFILES)
RCLINK=
RCLINKFLAGS=
RCSETVERSION=

DLLPOSTFIX=si

DLLPRE=lib
DLLPOST=.so

LDUMP=cppfilt /b /n /o /p

CDEFS += -D_PTHREADS  
#CFLAGS += -U_REENTRANT -U_POSIX_PTHREAD_SEMANTICS
CFLAGSCXXSLO += -instances=static
CFLAGSCXXOBJ += -instances=static

LINKFLAGSAPPGUI+= -instances=static
LINKFLAGSSHLGUI+= -instances=static
LINKFLAGSAPPCUI+= -instances=static
LINKFLAGSSHLCUI+= -instances=static

